

# IngestKnowledgeBaseDocuments


Ingests documents directly into the knowledge base that is connected to the data source. The `dataSourceType` specified in the content for each document must match the type of the data source that you specify in the header. For more information, see [Ingest changes directly into a knowledge base](https://docs.aws.amazon.com/bedrock/latest/userguide/kb-direct-ingestion.html) in the Amazon Bedrock User Guide.

## Request Syntax


```
PUT /knowledgebases/knowledgeBaseId/datasources/dataSourceId/documents HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "documents": [ 
      { 
         "content": { 
            "custom": { 
               "customDocumentIdentifier": { 
                  "id": "string"
               },
               "inlineContent": { 
                  "byteContent": { 
                     "data": blob,
                     "mimeType": "string"
                  },
                  "textContent": { 
                     "data": "string"
                  },
                  "type": "string"
               },
               "s3Location": { 
                  "bucketOwnerAccountId": "string",
                  "uri": "string"
               },
               "sourceType": "string"
            },
            "dataSourceType": "string",
            "s3": { 
               "s3Location": { 
                  "uri": "string"
               }
            }
         },
         "metadata": { 
            "inlineAttributes": [ 
               { 
                  "key": "string",
                  "value": { 
                     "booleanValue": boolean,
                     "numberValue": number,
                     "stringListValue": [ "string" ],
                     "stringValue": "string",
                     "type": "string"
                  }
               }
            ],
            "s3Location": { 
               "bucketOwnerAccountId": "string",
               "uri": "string"
            },
            "type": "string"
         }
      }
   ]
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [dataSourceId](#API_agent_IngestKnowledgeBaseDocuments_RequestSyntax) **   <a name="bedrock-agent_IngestKnowledgeBaseDocuments-request-uri-dataSourceId"></a>
The unique identifier of the data source connected to the knowledge base that you're adding documents to.  
Pattern: `[0-9a-zA-Z]{10}`   
Required: Yes

 ** [knowledgeBaseId](#API_agent_IngestKnowledgeBaseDocuments_RequestSyntax) **   <a name="bedrock-agent_IngestKnowledgeBaseDocuments-request-uri-knowledgeBaseId"></a>
The unique identifier of the knowledge base to ingest the documents into.  
Pattern: `[0-9a-zA-Z]{10}`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [clientToken](#API_agent_IngestKnowledgeBaseDocuments_RequestSyntax) **   <a name="bedrock-agent_IngestKnowledgeBaseDocuments-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the API request completes no more than one time. If this token matches a previous request, Amazon Bedrock ignores the request, but does not return an error. For more information, see [Ensuring idempotency](https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Run_Instance_Idempotency.html).  
Type: String  
Length Constraints: Minimum length of 33. Maximum length of 256.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,256}`   
Required: No

 ** [documents](#API_agent_IngestKnowledgeBaseDocuments_RequestSyntax) **   <a name="bedrock-agent_IngestKnowledgeBaseDocuments-request-documents"></a>
A list of objects, each of which contains information about the documents to add.  
Type: Array of [KnowledgeBaseDocument](API_agent_KnowledgeBaseDocument.md) objects  
Array Members: Minimum number of 1 item. Maximum number of 10 items.  
Required: Yes

## Response Syntax


```
HTTP/1.1 202
Content-type: application/json

{
   "documentDetails": [ 
      { 
         "dataSourceId": "string",
         "identifier": { 
            "custom": { 
               "id": "string"
            },
            "dataSourceType": "string",
            "s3": { 
               "uri": "string"
            }
         },
         "knowledgeBaseId": "string",
         "status": "string",
         "statusReason": "string",
         "updatedAt": "string"
      }
   ]
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 202 response.

The following data is returned in JSON format by the service.

 ** [documentDetails](#API_agent_IngestKnowledgeBaseDocuments_ResponseSyntax) **   <a name="bedrock-agent_IngestKnowledgeBaseDocuments-response-documentDetails"></a>
A list of objects, each of which contains information about the documents that were ingested.  
Type: Array of [KnowledgeBaseDocumentDetail](API_agent_KnowledgeBaseDocumentDetail.md) objects

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
The request is denied because of missing access permissions.  
HTTP Status Code: 403

 ** InternalServerException **   
An internal server error occurred. Retry your request.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource Amazon Resource Name (ARN) was not found. Check the Amazon Resource Name (ARN) and try your request again.  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
The number of requests exceeds the service quota. Resubmit your request later.  
HTTP Status Code: 402

 ** ThrottlingException **   
The number of requests exceeds the limit. Resubmit your request later.  
HTTP Status Code: 429

 ** ValidationException **   
Input validation failed. Check your request parameters and retry the request.    
 ** fieldList **   
A list of objects containing fields that caused validation errors and their corresponding validation error messages.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/bedrock-agent-2023-06-05/IngestKnowledgeBaseDocuments) 